import math

def simple_newton(x0, n, xreal):
    fpx0 = fp(x0) # benefit of simple newton is reduced computations. storing f'(x0) to be reused reduced needed computations
    x = x0
    for i in range(n):
         x = x - (f(x)/fpx0)
         error = "not defined"
         if xreal is not None:
            error = abs(xreal - x)
         print("x{i}: {x}\nerror: {error}\n".format(x=x,error=error,i=i+1))
    return x

# your function f(x)
def f(x):
    return math.cos(x) - x

# f'(x), aka the derivative of f(x)
def fp(x):
    return -1 * math.sin(x) - 1


#x0, aka your initial guess
x0 = .73

# n sets iteration count
n = 7

# if the real value of x is known, you can put it here to have the script calculate error
xreal = None

# Call the function
result = simple_newton(x0,n,xreal)
print("Root found at:", result)
